/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * ARLAS Server APIs
 * Explore the content of ARLAS collections
 *
 * OpenAPI spec version: 27.0.1
 * Contact: contact@gisaia.com
 *
 * NOTE: This file is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the file manually.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as url from "url";
import * as isomorphicFetch from "isomorphic-fetch";
var BASE_PATH = "/arlas".replace(/\/+$/, "");
/**
 *
 * @export
 */
export var COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};
/**
 *
 * @export
 * @class BaseAPI
 */
var BaseAPI = (function () {
    function BaseAPI(configuration, basePath, fetch) {
        if (basePath === void 0) { basePath = BASE_PATH; }
        if (fetch === void 0) { fetch = isomorphicFetch; }
        this.basePath = basePath;
        this.fetch = fetch;
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
    return BaseAPI;
}());
export { BaseAPI };
;
/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
var RequiredError = (function (_super) {
    __extends(RequiredError, _super);
    function RequiredError(field, msg) {
        var _this = _super.call(this, msg) || this;
        _this.field = field;
        return _this;
    }
    return RequiredError;
}(Error));
export { RequiredError };
/**
 * @export
 * @namespace Aggregation
 */
export var Aggregation;
(function (Aggregation) {
    /**
     * @export
     * @enum {string}
     */
    var TypeEnum;
    (function (TypeEnum) {
        TypeEnum[TypeEnum["Datehistogram"] = 'datehistogram'] = "Datehistogram";
        TypeEnum[TypeEnum["Geohash"] = 'geohash'] = "Geohash";
        TypeEnum[TypeEnum["Geotile"] = 'geotile'] = "Geotile";
        TypeEnum[TypeEnum["Histogram"] = 'histogram'] = "Histogram";
        TypeEnum[TypeEnum["Term"] = 'term'] = "Term";
        TypeEnum[TypeEnum["Geohex"] = 'geohex'] = "Geohex";
    })(TypeEnum = Aggregation.TypeEnum || (Aggregation.TypeEnum = {}));
    /**
     * @export
     * @enum {string}
     */
    var OrderEnum;
    (function (OrderEnum) {
        OrderEnum[OrderEnum["Asc"] = 'asc'] = "Asc";
        OrderEnum[OrderEnum["Desc"] = 'desc'] = "Desc";
    })(OrderEnum = Aggregation.OrderEnum || (Aggregation.OrderEnum = {}));
    /**
     * @export
     * @enum {string}
     */
    var OnEnum;
    (function (OnEnum) {
        OnEnum[OnEnum["Field"] = 'field'] = "Field";
        OnEnum[OnEnum["Count"] = 'count'] = "Count";
        OnEnum[OnEnum["Result"] = 'result'] = "Result";
    })(OnEnum = Aggregation.OnEnum || (Aggregation.OnEnum = {}));
    /**
     * @export
     * @enum {string}
     */
    var AggregatedGeometriesEnum;
    (function (AggregatedGeometriesEnum) {
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["BBOX"] = 'BBOX'] = "BBOX";
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["CENTROID"] = 'CENTROID'] = "CENTROID";
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["CELL"] = 'CELL'] = "CELL";
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["CELLCENTER"] = 'CELLCENTER'] = "CELLCENTER";
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["GEOHASH"] = 'GEOHASH'] = "GEOHASH";
        AggregatedGeometriesEnum[AggregatedGeometriesEnum["GEOHASHCENTER"] = 'GEOHASH_CENTER'] = "GEOHASHCENTER";
    })(AggregatedGeometriesEnum = Aggregation.AggregatedGeometriesEnum || (Aggregation.AggregatedGeometriesEnum = {}));
})(Aggregation || (Aggregation = {}));
/**
 * @export
 * @namespace CollectionReferenceDescriptionProperty
 */
export var CollectionReferenceDescriptionProperty;
(function (CollectionReferenceDescriptionProperty) {
    /**
     * @export
     * @enum {string}
     */
    var TypeEnum;
    (function (TypeEnum) {
        TypeEnum[TypeEnum["TEXT"] = 'TEXT'] = "TEXT";
        TypeEnum[TypeEnum["KEYWORD"] = 'KEYWORD'] = "KEYWORD";
        TypeEnum[TypeEnum["LONG"] = 'LONG'] = "LONG";
        TypeEnum[TypeEnum["INTEGER"] = 'INTEGER'] = "INTEGER";
        TypeEnum[TypeEnum["SHORT"] = 'SHORT'] = "SHORT";
        TypeEnum[TypeEnum["BYTE"] = 'BYTE'] = "BYTE";
        TypeEnum[TypeEnum["DOUBLE"] = 'DOUBLE'] = "DOUBLE";
        TypeEnum[TypeEnum["FLOAT"] = 'FLOAT'] = "FLOAT";
        TypeEnum[TypeEnum["DATE"] = 'DATE'] = "DATE";
        TypeEnum[TypeEnum["BOOLEAN"] = 'BOOLEAN'] = "BOOLEAN";
        TypeEnum[TypeEnum["BINARY"] = 'BINARY'] = "BINARY";
        TypeEnum[TypeEnum["INTRANGE"] = 'INT_RANGE'] = "INTRANGE";
        TypeEnum[TypeEnum["FLOATRANGE"] = 'FLOAT_RANGE'] = "FLOATRANGE";
        TypeEnum[TypeEnum["LONGRANGE"] = 'LONG_RANGE'] = "LONGRANGE";
        TypeEnum[TypeEnum["DOUBLERANGE"] = 'DOUBLE_RANGE'] = "DOUBLERANGE";
        TypeEnum[TypeEnum["DATERANGE"] = 'DATE_RANGE'] = "DATERANGE";
        TypeEnum[TypeEnum["OBJECT"] = 'OBJECT'] = "OBJECT";
        TypeEnum[TypeEnum["NESTED"] = 'NESTED'] = "NESTED";
        TypeEnum[TypeEnum["GEOPOINT"] = 'GEO_POINT'] = "GEOPOINT";
        TypeEnum[TypeEnum["GEOSHAPE"] = 'GEO_SHAPE'] = "GEOSHAPE";
        TypeEnum[TypeEnum["IP"] = 'IP'] = "IP";
        TypeEnum[TypeEnum["COMPLETION"] = 'COMPLETION'] = "COMPLETION";
        TypeEnum[TypeEnum["TOKENCOUNT"] = 'TOKEN_COUNT'] = "TOKENCOUNT";
        TypeEnum[TypeEnum["MAPPERMURMUR3"] = 'MAPPER_MURMUR3'] = "MAPPERMURMUR3";
        TypeEnum[TypeEnum["UNKNOWN"] = 'UNKNOWN'] = "UNKNOWN";
        TypeEnum[TypeEnum["VARCHAR"] = 'VARCHAR'] = "VARCHAR";
        TypeEnum[TypeEnum["CHAR"] = 'CHAR'] = "CHAR";
        TypeEnum[TypeEnum["CHARACTER"] = 'CHARACTER'] = "CHARACTER";
        TypeEnum[TypeEnum["BIT"] = 'BIT'] = "BIT";
        TypeEnum[TypeEnum["TINYINT"] = 'TINYINT'] = "TINYINT";
        TypeEnum[TypeEnum["SMALLINT"] = 'SMALLINT'] = "SMALLINT";
        TypeEnum[TypeEnum["INT"] = 'INT'] = "INT";
        TypeEnum[TypeEnum["BIGINT"] = 'BIGINT'] = "BIGINT";
        TypeEnum[TypeEnum["DECIMAL"] = 'DECIMAL'] = "DECIMAL";
        TypeEnum[TypeEnum["NUMERIC"] = 'NUMERIC'] = "NUMERIC";
        TypeEnum[TypeEnum["REAL"] = 'REAL'] = "REAL";
        TypeEnum[TypeEnum["DOUBLEPRECISION"] = 'DOUBLEPRECISION'] = "DOUBLEPRECISION";
        TypeEnum[TypeEnum["TIMESTAMP"] = 'TIMESTAMP'] = "TIMESTAMP";
        TypeEnum[TypeEnum["TIME"] = 'TIME'] = "TIME";
        TypeEnum[TypeEnum["INTERVAL"] = 'INTERVAL'] = "INTERVAL";
        TypeEnum[TypeEnum["GEOMETRY"] = 'GEOMETRY'] = "GEOMETRY";
        TypeEnum[TypeEnum["GEOGRAPHY"] = 'GEOGRAPHY'] = "GEOGRAPHY";
        TypeEnum[TypeEnum["POINT"] = 'POINT'] = "POINT";
        TypeEnum[TypeEnum["LINESTRING"] = 'LINESTRING'] = "LINESTRING";
        TypeEnum[TypeEnum["POLYGON"] = 'POLYGON'] = "POLYGON";
        TypeEnum[TypeEnum["MULTIPOINT"] = 'MULTIPOINT'] = "MULTIPOINT";
        TypeEnum[TypeEnum["MULTILINESTRING"] = 'MULTILINESTRING'] = "MULTILINESTRING";
        TypeEnum[TypeEnum["MULTIPOLYGON"] = 'MULTIPOLYGON'] = "MULTIPOLYGON";
        TypeEnum[TypeEnum["GEOMETRYCOLLECTION"] = 'GEOMETRYCOLLECTION'] = "GEOMETRYCOLLECTION";
        TypeEnum[TypeEnum["MURMUR3"] = 'MURMUR3'] = "MURMUR3";
    })(TypeEnum = CollectionReferenceDescriptionProperty.TypeEnum || (CollectionReferenceDescriptionProperty.TypeEnum = {}));
})(CollectionReferenceDescriptionProperty || (CollectionReferenceDescriptionProperty = {}));
/**
 * @export
 * @namespace ComputationRequest
 */
export var ComputationRequest;
(function (ComputationRequest) {
    /**
     * @export
     * @enum {string}
     */
    var MetricEnum;
    (function (MetricEnum) {
        MetricEnum[MetricEnum["AVG"] = 'AVG'] = "AVG";
        MetricEnum[MetricEnum["MAX"] = 'MAX'] = "MAX";
        MetricEnum[MetricEnum["MIN"] = 'MIN'] = "MIN";
        MetricEnum[MetricEnum["SUM"] = 'SUM'] = "SUM";
        MetricEnum[MetricEnum["CARDINALITY"] = 'CARDINALITY'] = "CARDINALITY";
        MetricEnum[MetricEnum["SPANNING"] = 'SPANNING'] = "SPANNING";
        MetricEnum[MetricEnum["GEOBBOX"] = 'GEOBBOX'] = "GEOBBOX";
        MetricEnum[MetricEnum["GEOCENTROID"] = 'GEOCENTROID'] = "GEOCENTROID";
    })(MetricEnum = ComputationRequest.MetricEnum || (ComputationRequest.MetricEnum = {}));
})(ComputationRequest || (ComputationRequest = {}));
/**
 * @export
 * @namespace ComputationResponse
 */
export var ComputationResponse;
(function (ComputationResponse) {
    /**
     * @export
     * @enum {string}
     */
    var MetricEnum;
    (function (MetricEnum) {
        MetricEnum[MetricEnum["AVG"] = 'AVG'] = "AVG";
        MetricEnum[MetricEnum["MAX"] = 'MAX'] = "MAX";
        MetricEnum[MetricEnum["MIN"] = 'MIN'] = "MIN";
        MetricEnum[MetricEnum["SUM"] = 'SUM'] = "SUM";
        MetricEnum[MetricEnum["CARDINALITY"] = 'CARDINALITY'] = "CARDINALITY";
        MetricEnum[MetricEnum["SPANNING"] = 'SPANNING'] = "SPANNING";
        MetricEnum[MetricEnum["GEOBBOX"] = 'GEOBBOX'] = "GEOBBOX";
        MetricEnum[MetricEnum["GEOCENTROID"] = 'GEOCENTROID'] = "GEOCENTROID";
    })(MetricEnum = ComputationResponse.MetricEnum || (ComputationResponse.MetricEnum = {}));
})(ComputationResponse || (ComputationResponse = {}));
/**
 * @export
 * @namespace Crs
 */
export var Crs;
(function (Crs) {
    /**
     * @export
     * @enum {string}
     */
    var TypeEnum;
    (function (TypeEnum) {
        TypeEnum[TypeEnum["Name"] = 'name'] = "Name";
        TypeEnum[TypeEnum["Link"] = 'link'] = "Link";
    })(TypeEnum = Crs.TypeEnum || (Crs.TypeEnum = {}));
})(Crs || (Crs = {}));
/**
 * @export
 * @namespace Expression
 */
export var Expression;
(function (Expression) {
    /**
     * @export
     * @enum {string}
     */
    var OpEnum;
    (function (OpEnum) {
        OpEnum[OpEnum["Eq"] = 'eq'] = "Eq";
        OpEnum[OpEnum["Gte"] = 'gte'] = "Gte";
        OpEnum[OpEnum["Gt"] = 'gt'] = "Gt";
        OpEnum[OpEnum["Lte"] = 'lte'] = "Lte";
        OpEnum[OpEnum["Lt"] = 'lt'] = "Lt";
        OpEnum[OpEnum["Like"] = 'like'] = "Like";
        OpEnum[OpEnum["Ne"] = 'ne'] = "Ne";
        OpEnum[OpEnum["Range"] = 'range'] = "Range";
        OpEnum[OpEnum["Within"] = 'within'] = "Within";
        OpEnum[OpEnum["Notwithin"] = 'notwithin'] = "Notwithin";
        OpEnum[OpEnum["Intersects"] = 'intersects'] = "Intersects";
        OpEnum[OpEnum["Notintersects"] = 'notintersects'] = "Notintersects";
    })(OpEnum = Expression.OpEnum || (Expression.OpEnum = {}));
})(Expression || (Expression = {}));
/**
 * @export
 * @namespace Interval
 */
export var Interval;
(function (Interval) {
    /**
     * @export
     * @enum {string}
     */
    var UnitEnum;
    (function (UnitEnum) {
        UnitEnum[UnitEnum["Year"] = 'year'] = "Year";
        UnitEnum[UnitEnum["Quarter"] = 'quarter'] = "Quarter";
        UnitEnum[UnitEnum["Month"] = 'month'] = "Month";
        UnitEnum[UnitEnum["Week"] = 'week'] = "Week";
        UnitEnum[UnitEnum["Day"] = 'day'] = "Day";
        UnitEnum[UnitEnum["Hour"] = 'hour'] = "Hour";
        UnitEnum[UnitEnum["Minute"] = 'minute'] = "Minute";
        UnitEnum[UnitEnum["Second"] = 'second'] = "Second";
    })(UnitEnum = Interval.UnitEnum || (Interval.UnitEnum = {}));
})(Interval || (Interval = {}));
/**
 * @export
 * @namespace Metric
 */
export var Metric;
(function (Metric) {
    /**
     * @export
     * @enum {string}
     */
    var CollectFctEnum;
    (function (CollectFctEnum) {
        CollectFctEnum[CollectFctEnum["AVG"] = 'AVG'] = "AVG";
        CollectFctEnum[CollectFctEnum["CARDINALITY"] = 'CARDINALITY'] = "CARDINALITY";
        CollectFctEnum[CollectFctEnum["MAX"] = 'MAX'] = "MAX";
        CollectFctEnum[CollectFctEnum["MIN"] = 'MIN'] = "MIN";
        CollectFctEnum[CollectFctEnum["SUM"] = 'SUM'] = "SUM";
        CollectFctEnum[CollectFctEnum["GEOCENTROID"] = 'GEOCENTROID'] = "GEOCENTROID";
        CollectFctEnum[CollectFctEnum["GEOBBOX"] = 'GEOBBOX'] = "GEOBBOX";
    })(CollectFctEnum = Metric.CollectFctEnum || (Metric.CollectFctEnum = {}));
})(Metric || (Metric = {}));
/**
 * CollectionsApi - fetch parameter creator
 * @export
 */
export var CollectionsApiFetchParamCreator = function (configuration) {
    return {
        /**
         * Delete a collection reference in ARLAS
         * @summary Delete a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        _delete: function (collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling _delete.');
            }
            var localVarPath = "/collections/{collection}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'DELETE' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get all collection references in ARLAS as json file
         * @summary Get all collection references as a json file
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exportCollections: function (options) {
            if (options === void 0) { options = {}; }
            var localVarPath = "/collections/_export";
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get a collection reference in ARLAS
         * @summary Get a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        get: function (collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling get.');
            }
            var localVarPath = "/collections/{collection}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Get all collection references in ARLAS
         * @summary Get all collection references
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAll: function (pretty, options) {
            if (options === void 0) { options = {}; }
            var localVarPath = "/collections";
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Add collection references in ARLAS from a json file
         * @summary Add collection references from a json file
         * @param {FormDataContentDisposition} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        importCollections: function (file, options) {
            if (options === void 0) { options = {}; }
            var localVarPath = "/collections/_import";
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            var localVarFormParams = new url.URLSearchParams();
            if (file !== undefined) {
                localVarFormParams.set('file', file);
            }
            localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            localVarRequestOptions.body = localVarFormParams.toString();
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update a collection reference's organisations attribute.
         * @summary Update a collection reference's organisations attribute.
         * @param {CollectionReferenceUpdateOrg} body organisationsParamsUpdate
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patch: function (body, collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling patch.');
            }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling patch.');
            }
            var localVarPath = "/collections/{collection}/organisations"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'PATCH' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("CollectionReferenceUpdateOrg" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update a collection reference's display collection name attribute.
         * @summary Update a collection reference's display collection name attribute.
         * @param {string} body collectionDisplayName
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchCollectionDisplayName: function (body, collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling patchCollectionDisplayName.');
            }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling patchCollectionDisplayName.');
            }
            var localVarPath = "/collections/{collection}/display_names/collection"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'PATCH' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("string" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update a collection reference's display fields name attribute.
         * @summary Update a collection reference's display fields name attribute.
         * @param {{ [key: string]: string; }} body fieldsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchFieldsDisplayNames: function (body, collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling patchFieldsDisplayNames.');
            }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling patchFieldsDisplayNames.');
            }
            var localVarPath = "/collections/{collection}/display_names/fields"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'PATCH' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("{ [key: string]: string; }" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Update a collection reference's display shape columns name attribute.
         * @summary Update a collection reference's display shape columns name attribute.
         * @param {{ [key: string]: string; }} body shapeColumnsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchShapeColumnsDisplayNames: function (body, collection, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling patchShapeColumnsDisplayNames.');
            }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling patchShapeColumnsDisplayNames.');
            }
            var localVarPath = "/collections/{collection}/display_names/shape_columns"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'PATCH' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("{ [key: string]: string; }" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Add a collection reference in ARLAS
         * @summary Add a collection reference
         * @param {CollectionReferenceParameters} body collectionParams
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [checkfields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        put: function (body, collection, pretty, checkfields, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body', 'Required parameter body was null or undefined when calling put.');
            }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling put.');
            }
            var localVarPath = "/collections/{collection}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'PUT' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (checkfields !== undefined) {
                localVarQueryParameter['checkfields'] = checkfields;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("CollectionReferenceParameters" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    };
};
/**
 * CollectionsApi - functional programming interface
 * @export
 */
export var CollectionsApiFp = function (configuration) {
    return {
        /**
         * Delete a collection reference in ARLAS
         * @summary Delete a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        _delete: function (collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration)._delete(collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get all collection references in ARLAS as json file
         * @summary Get all collection references as a json file
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exportCollections: function (options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).exportCollections(options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get a collection reference in ARLAS
         * @summary Get a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        get: function (collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).get(collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Get all collection references in ARLAS
         * @summary Get all collection references
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAll: function (pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).getAll(pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Add collection references in ARLAS from a json file
         * @summary Add collection references from a json file
         * @param {FormDataContentDisposition} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        importCollections: function (file, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).importCollections(file, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Update a collection reference's organisations attribute.
         * @summary Update a collection reference's organisations attribute.
         * @param {CollectionReferenceUpdateOrg} body organisationsParamsUpdate
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patch: function (body, collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).patch(body, collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Update a collection reference's display collection name attribute.
         * @summary Update a collection reference's display collection name attribute.
         * @param {string} body collectionDisplayName
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchCollectionDisplayName: function (body, collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).patchCollectionDisplayName(body, collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Update a collection reference's display fields name attribute.
         * @summary Update a collection reference's display fields name attribute.
         * @param {{ [key: string]: string; }} body fieldsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchFieldsDisplayNames: function (body, collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).patchFieldsDisplayNames(body, collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Update a collection reference's display shape columns name attribute.
         * @summary Update a collection reference's display shape columns name attribute.
         * @param {{ [key: string]: string; }} body shapeColumnsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchShapeColumnsDisplayNames: function (body, collection, pretty, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).patchShapeColumnsDisplayNames(body, collection, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Add a collection reference in ARLAS
         * @summary Add a collection reference
         * @param {CollectionReferenceParameters} body collectionParams
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [checkfields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        put: function (body, collection, pretty, checkfields, options) {
            var localVarFetchArgs = CollectionsApiFetchParamCreator(configuration).put(body, collection, pretty, checkfields, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
    };
};
/**
 * CollectionsApi - factory interface
 * @export
 */
export var CollectionsApiFactory = function (configuration, fetch, basePath) {
    return {
        /**
         * Delete a collection reference in ARLAS
         * @summary Delete a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        _delete: function (collection, pretty, options) {
            return CollectionsApiFp(configuration)._delete(collection, pretty, options)(fetch, basePath);
        },
        /**
         * Get all collection references in ARLAS as json file
         * @summary Get all collection references as a json file
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exportCollections: function (options) {
            return CollectionsApiFp(configuration).exportCollections(options)(fetch, basePath);
        },
        /**
         * Get a collection reference in ARLAS
         * @summary Get a collection reference
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        get: function (collection, pretty, options) {
            return CollectionsApiFp(configuration).get(collection, pretty, options)(fetch, basePath);
        },
        /**
         * Get all collection references in ARLAS
         * @summary Get all collection references
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAll: function (pretty, options) {
            return CollectionsApiFp(configuration).getAll(pretty, options)(fetch, basePath);
        },
        /**
         * Add collection references in ARLAS from a json file
         * @summary Add collection references from a json file
         * @param {FormDataContentDisposition} [file]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        importCollections: function (file, options) {
            return CollectionsApiFp(configuration).importCollections(file, options)(fetch, basePath);
        },
        /**
         * Update a collection reference's organisations attribute.
         * @summary Update a collection reference's organisations attribute.
         * @param {CollectionReferenceUpdateOrg} body organisationsParamsUpdate
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patch: function (body, collection, pretty, options) {
            return CollectionsApiFp(configuration).patch(body, collection, pretty, options)(fetch, basePath);
        },
        /**
         * Update a collection reference's display collection name attribute.
         * @summary Update a collection reference's display collection name attribute.
         * @param {string} body collectionDisplayName
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchCollectionDisplayName: function (body, collection, pretty, options) {
            return CollectionsApiFp(configuration).patchCollectionDisplayName(body, collection, pretty, options)(fetch, basePath);
        },
        /**
         * Update a collection reference's display fields name attribute.
         * @summary Update a collection reference's display fields name attribute.
         * @param {{ [key: string]: string; }} body fieldsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchFieldsDisplayNames: function (body, collection, pretty, options) {
            return CollectionsApiFp(configuration).patchFieldsDisplayNames(body, collection, pretty, options)(fetch, basePath);
        },
        /**
         * Update a collection reference's display shape columns name attribute.
         * @summary Update a collection reference's display shape columns name attribute.
         * @param {{ [key: string]: string; }} body shapeColumnsDisplayNames
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        patchShapeColumnsDisplayNames: function (body, collection, pretty, options) {
            return CollectionsApiFp(configuration).patchShapeColumnsDisplayNames(body, collection, pretty, options)(fetch, basePath);
        },
        /**
         * Add a collection reference in ARLAS
         * @summary Add a collection reference
         * @param {CollectionReferenceParameters} body collectionParams
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [checkfields]
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        put: function (body, collection, pretty, checkfields, options) {
            return CollectionsApiFp(configuration).put(body, collection, pretty, checkfields, options)(fetch, basePath);
        },
    };
};
/**
 * CollectionsApi - object-oriented interface
 * @export
 * @class CollectionsApi
 * @extends {BaseAPI}
 */
var CollectionsApi = (function (_super) {
    __extends(CollectionsApi, _super);
    function CollectionsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Delete a collection reference in ARLAS
     * @summary Delete a collection reference
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype._delete = function (collection, pretty, options) {
        return CollectionsApiFp(this.configuration)._delete(collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Get all collection references in ARLAS as json file
     * @summary Get all collection references as a json file
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.exportCollections = function (options) {
        return CollectionsApiFp(this.configuration).exportCollections(options)(this.fetch, this.basePath);
    };
    /**
     * Get a collection reference in ARLAS
     * @summary Get a collection reference
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.get = function (collection, pretty, options) {
        return CollectionsApiFp(this.configuration).get(collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Get all collection references in ARLAS
     * @summary Get all collection references
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.getAll = function (pretty, options) {
        return CollectionsApiFp(this.configuration).getAll(pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Add collection references in ARLAS from a json file
     * @summary Add collection references from a json file
     * @param {FormDataContentDisposition} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.importCollections = function (file, options) {
        return CollectionsApiFp(this.configuration).importCollections(file, options)(this.fetch, this.basePath);
    };
    /**
     * Update a collection reference's organisations attribute.
     * @summary Update a collection reference's organisations attribute.
     * @param {CollectionReferenceUpdateOrg} body organisationsParamsUpdate
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.patch = function (body, collection, pretty, options) {
        return CollectionsApiFp(this.configuration).patch(body, collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Update a collection reference's display collection name attribute.
     * @summary Update a collection reference's display collection name attribute.
     * @param {string} body collectionDisplayName
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.patchCollectionDisplayName = function (body, collection, pretty, options) {
        return CollectionsApiFp(this.configuration).patchCollectionDisplayName(body, collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Update a collection reference's display fields name attribute.
     * @summary Update a collection reference's display fields name attribute.
     * @param {{ [key: string]: string; }} body fieldsDisplayNames
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.patchFieldsDisplayNames = function (body, collection, pretty, options) {
        return CollectionsApiFp(this.configuration).patchFieldsDisplayNames(body, collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Update a collection reference's display shape columns name attribute.
     * @summary Update a collection reference's display shape columns name attribute.
     * @param {{ [key: string]: string; }} body shapeColumnsDisplayNames
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.patchShapeColumnsDisplayNames = function (body, collection, pretty, options) {
        return CollectionsApiFp(this.configuration).patchShapeColumnsDisplayNames(body, collection, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Add a collection reference in ARLAS
     * @summary Add a collection reference
     * @param {CollectionReferenceParameters} body collectionParams
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [checkfields]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CollectionsApi
     */
    CollectionsApi.prototype.put = function (body, collection, pretty, checkfields, options) {
        return CollectionsApiFp(this.configuration).put(body, collection, pretty, checkfields, options)(this.fetch, this.basePath);
    };
    return CollectionsApi;
}(BaseAPI));
export { CollectionsApi };
/**
 * ExploreApi - fetch parameter creator
 * @export
 */
export var ExploreApiFetchParamCreator = function (configuration) {
    return {
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:fetch_hits-{fetch_hits values}    Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.       - It&#x27;s possible to apply multiple metric aggregations by defining multiple (**collect_field**,**collect_fct**) couples.      - (**collect_field**,**collect_fct**) couples should be unique in that case.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           datehistogram, histogram, geohash, geotile and term.    - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6.           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - If {on} is equal to &#x60;result&#x60; and two or more (**collect_field**,**collect_fct**) couples are specified, then the order is applied on the first &#x60;collect_fct&#x60; that is different from geobbox and geocentroid   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell extent (zxy or geohash) of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the aggregated form, the geojson geometry and an attribute &#x60;is_raw&#x60; set to false       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,cell&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the geometry path, the used sort, the geojson geometry and an attribute &#x60;is_raw&#x60; set to true       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling aggregate.');
            }
            // verify required parameter 'agg' is not null or undefined
            if (agg === null || agg === undefined) {
                throw new RequiredError('agg', 'Required parameter agg was null or undefined when calling aggregate.');
            }
            var localVarPath = "/explore/{collection}/_aggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (agg) {
                localVarQueryParameter['agg'] = agg;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregatePost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling aggregatePost.');
            }
            var localVarPath = "/explore/{collection}/_aggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("AggregationsRequest" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {string} field The field on which the metric is calculated.
         * @param {string} metric The metric to compute : &#x60;max, min, avg, sum, cardinality, spanning, geobbox, geocentroid&#x60;.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        compute: function (collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling compute.');
            }
            // verify required parameter 'field' is not null or undefined
            if (field === null || field === undefined) {
                throw new RequiredError('field', 'Required parameter field was null or undefined when calling compute.');
            }
            // verify required parameter 'metric' is not null or undefined
            if (metric === null || metric === undefined) {
                throw new RequiredError('metric', 'Required parameter metric was null or undefined when calling compute.');
            }
            var localVarPath = "/explore/{collection}/_compute"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (field !== undefined) {
                localVarQueryParameter['field'] = field;
            }
            if (metric !== undefined) {
                localVarQueryParameter['metric'] = metric;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {ComputationRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        computePost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling computePost.');
            }
            var localVarPath = "/explore/{collection}/_compute"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("ComputationRequest" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        count: function (collection, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling count.');
            }
            var localVarPath = "/explore/{collection}/_count"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Count} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        countPost: function (collection, body, pretty, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling countPost.');
            }
            var localVarPath = "/explore/{collection}/_count"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("Count" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Describe the structure and the content of the given collection.
         * @summary Describe
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        describe: function (collection, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling describe.');
            }
            var localVarPath = "/explore/{collection}/_describe"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geoaggregate.');
            }
            // verify required parameter 'agg' is not null or undefined
            if (agg === null || agg === undefined) {
                throw new RequiredError('agg', 'Required parameter agg was null or undefined when calling geoaggregate.');
            }
            var localVarPath = "/explore/{collection}/_geoaggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (agg) {
                localVarQueryParameter['agg'] = agg;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geoaggregatePost.');
            }
            var localVarPath = "/explore/{collection}/_geoaggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("AggregationsRequest" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given geohash as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geohash
         * @param {string} collection collection
         * @param {string} geohash geohash
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geohashgeoaggregate: function (collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geohashgeoaggregate.');
            }
            // verify required parameter 'geohash' is not null or undefined
            if (geohash === null || geohash === undefined) {
                throw new RequiredError('geohash', 'Required parameter geohash was null or undefined when calling geohashgeoaggregate.');
            }
            var localVarPath = "/explore/{collection}/_geoaggregate/{geohash}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)))
                .replace("{" + "geohash" + "}", encodeURIComponent(String(geohash)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (agg) {
                localVarQueryParameter['agg'] = agg;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geosearch.');
            }
            var localVarPath = "/explore/{collection}/_geosearch"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (include !== undefined) {
                localVarQueryParameter['include'] = include;
            }
            if (exclude !== undefined) {
                localVarQueryParameter['exclude'] = exclude;
            }
            if (returned_geometries !== undefined) {
                localVarQueryParameter['returned_geometries'] = returned_geometries;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (after !== undefined) {
                localVarQueryParameter['after'] = after;
            }
            if (before !== undefined) {
                localVarQueryParameter['before'] = before;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearchPost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geosearchPost.');
            }
            var localVarPath = "/explore/{collection}/_geosearch"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("Search" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given tile as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geotile
         * @param {string} collection collection
         * @param {number} z z
         * @param {number} x x
         * @param {number} y y
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geotilegeoaggregate: function (collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling geotilegeoaggregate.');
            }
            // verify required parameter 'z' is not null or undefined
            if (z === null || z === undefined) {
                throw new RequiredError('z', 'Required parameter z was null or undefined when calling geotilegeoaggregate.');
            }
            // verify required parameter 'x' is not null or undefined
            if (x === null || x === undefined) {
                throw new RequiredError('x', 'Required parameter x was null or undefined when calling geotilegeoaggregate.');
            }
            // verify required parameter 'y' is not null or undefined
            if (y === null || y === undefined) {
                throw new RequiredError('y', 'Required parameter y was null or undefined when calling geotilegeoaggregate.');
            }
            var localVarPath = "/explore/{collection}/_geoaggregate/{z}/{x}/{y}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)))
                .replace("{" + "z" + "}", encodeURIComponent(String(z)))
                .replace("{" + "x" + "}", encodeURIComponent(String(x)))
                .replace("{" + "y" + "}", encodeURIComponent(String(y)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (agg) {
                localVarQueryParameter['agg'] = agg;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Returns a raw indexed document.
         * @summary Get an Arlas document
         * @param {string} collection collection
         * @param {string} identifier identifier
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getArlasHit: function (collection, identifier, pretty, flat, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling getArlasHit.');
            }
            // verify required parameter 'identifier' is not null or undefined
            if (identifier === null || identifier === undefined) {
                throw new RequiredError('identifier', 'Required parameter identifier was null or undefined when calling getArlasHit.');
            }
            var localVarPath = "/explore/{collection}/{identifier}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)))
                .replace("{" + "identifier" + "}", encodeURIComponent(String(identifier)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * List the collections configured in ARLAS.
         * @summary List
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: function (pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            var localVarPath = "/explore/_list";
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling search.');
            }
            var localVarPath = "/explore/{collection}/_search"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (include !== undefined) {
                localVarQueryParameter['include'] = include;
            }
            if (exclude !== undefined) {
                localVarQueryParameter['exclude'] = exclude;
            }
            if (returned_geometries !== undefined) {
                localVarQueryParameter['returned_geometries'] = returned_geometries;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (after !== undefined) {
                localVarQueryParameter['after'] = after;
            }
            if (before !== undefined) {
                localVarQueryParameter['before'] = before;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling searchPost.');
            }
            var localVarPath = "/explore/{collection}/_search"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("Search" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling shapeaggregate.');
            }
            // verify required parameter 'agg' is not null or undefined
            if (agg === null || agg === undefined) {
                throw new RequiredError('agg', 'Required parameter agg was null or undefined when calling shapeaggregate.');
            }
            var localVarPath = "/explore/{collection}/_shapeaggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (agg) {
                localVarQueryParameter['agg'] = agg;
            }
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling shapeaggregatePost.');
            }
            var localVarPath = "/explore/{collection}/_shapeaggregate"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("AggregationsRequest" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearch: function (collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling shapesearch.');
            }
            var localVarPath = "/explore/{collection}/_shapesearch"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (include !== undefined) {
                localVarQueryParameter['include'] = include;
            }
            if (exclude !== undefined) {
                localVarQueryParameter['exclude'] = exclude;
            }
            if (returned_geometries !== undefined) {
                localVarQueryParameter['returned_geometries'] = returned_geometries;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (after !== undefined) {
                localVarQueryParameter['after'] = after;
            }
            if (before !== undefined) {
                localVarQueryParameter['before'] = before;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearchPost: function (collection, body, pretty, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling shapesearchPost.');
            }
            var localVarPath = "/explore/{collection}/_shapesearch"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarHeaderParameter['Content-Type'] = 'application/json;charset=utf-8';
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            var needsSerialization = ("Search" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body = needsSerialization ? JSON.stringify(body || {}) : (body || "");
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Suggest the the n (n=size) most relevant terms given the filters
         * @summary Suggest
         * @param {string} collections collections, comma separated
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided. The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator   |                   Description                      | value type          :          |  {fieldName} equals {value}                        | numeric or strings           :gte:      |  {fieldName} is greater than or equal to  {value}  | numeric           :gt:       |  {fieldName} is greater than {value}               | numeric           :lte:      |  {fieldName} is less than or equal to {value}      | numeric           :lt:       |  {fieldName}  is less than {value}                 | numeric       - The AND operator is applied between filters having different fieldNames.    - The OR operator is applied on filters having the same fieldName.    - If the fieldName starts with - then a must not filter is used   - If the fieldName starts with - then a must not filter is used   For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md
         * @param {string} [q] A full text search
         * @param {boolean} [pretty] Pretty print
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [field] Name of the field to be used for retrieving the most relevant terms
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        suggest: function (collections, f, q, pretty, size, from, field, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collections' is not null or undefined
            if (collections === null || collections === undefined) {
                throw new RequiredError('collections', 'Required parameter collections was null or undefined when calling suggest.');
            }
            var localVarPath = "/explore/{collections}/_suggest"
                .replace("{" + "collections" + "}", encodeURIComponent(String(collections)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q !== undefined) {
                localVarQueryParameter['q'] = q;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (field !== undefined) {
                localVarQueryParameter['field'] = field;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch: function (collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling tiledgeosearch.');
            }
            // verify required parameter 'x' is not null or undefined
            if (x === null || x === undefined) {
                throw new RequiredError('x', 'Required parameter x was null or undefined when calling tiledgeosearch.');
            }
            // verify required parameter 'y' is not null or undefined
            if (y === null || y === undefined) {
                throw new RequiredError('y', 'Required parameter y was null or undefined when calling tiledgeosearch.');
            }
            // verify required parameter 'z' is not null or undefined
            if (z === null || z === undefined) {
                throw new RequiredError('z', 'Required parameter z was null or undefined when calling tiledgeosearch.');
            }
            var localVarPath = "/explore/{collection}/_geosearch/{z}/{x}/{y}"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)))
                .replace("{" + "x" + "}", encodeURIComponent(String(x)))
                .replace("{" + "y" + "}", encodeURIComponent(String(y)))
                .replace("{" + "z" + "}", encodeURIComponent(String(z)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (pretty !== undefined) {
                localVarQueryParameter['pretty'] = pretty;
            }
            if (flat !== undefined) {
                localVarQueryParameter['flat'] = flat;
            }
            if (include !== undefined) {
                localVarQueryParameter['include'] = include;
            }
            if (exclude !== undefined) {
                localVarQueryParameter['exclude'] = exclude;
            }
            if (returned_geometries !== undefined) {
                localVarQueryParameter['returned_geometries'] = returned_geometries;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (after !== undefined) {
                localVarQueryParameter['after'] = after;
            }
            if (before !== undefined) {
                localVarQueryParameter['before'] = before;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [sampling] Size of the sampling for testing transparency: 1: test every pixel, 10: test 1 pixel every 10 pixels, etc.
         * @param {number} [coverage] Percentage (]0-100]) of acceptable transparent pixels. Higher the percentage, more tiles could be used for filling the tile
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch1: function (collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'collection' is not null or undefined
            if (collection === null || collection === undefined) {
                throw new RequiredError('collection', 'Required parameter collection was null or undefined when calling tiledgeosearch1.');
            }
            // verify required parameter 'x' is not null or undefined
            if (x === null || x === undefined) {
                throw new RequiredError('x', 'Required parameter x was null or undefined when calling tiledgeosearch1.');
            }
            // verify required parameter 'y' is not null or undefined
            if (y === null || y === undefined) {
                throw new RequiredError('y', 'Required parameter y was null or undefined when calling tiledgeosearch1.');
            }
            // verify required parameter 'z' is not null or undefined
            if (z === null || z === undefined) {
                throw new RequiredError('z', 'Required parameter z was null or undefined when calling tiledgeosearch1.');
            }
            var localVarPath = "/explore/{collection}/_tile/{z}/{x}/{y}.png"
                .replace("{" + "collection" + "}", encodeURIComponent(String(collection)))
                .replace("{" + "x" + "}", encodeURIComponent(String(x)))
                .replace("{" + "y" + "}", encodeURIComponent(String(y)))
                .replace("{" + "z" + "}", encodeURIComponent(String(z)));
            var localVarUrlObj = url.parse(localVarPath, true);
            var localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (f) {
                localVarQueryParameter['f'] = f;
            }
            if (q) {
                localVarQueryParameter['q'] = q;
            }
            if (dateformat !== undefined) {
                localVarQueryParameter['dateformat'] = dateformat;
            }
            if (righthand !== undefined) {
                localVarQueryParameter['righthand'] = righthand;
            }
            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }
            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }
            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }
            if (after !== undefined) {
                localVarQueryParameter['after'] = after;
            }
            if (before !== undefined) {
                localVarQueryParameter['before'] = before;
            }
            if (sampling !== undefined) {
                localVarQueryParameter['sampling'] = sampling;
            }
            if (coverage !== undefined) {
                localVarQueryParameter['coverage'] = coverage;
            }
            if (max_age_cache !== undefined) {
                localVarQueryParameter['max-age-cache'] = max_age_cache;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    };
};
/**
 * ExploreApi - functional programming interface
 * @export
 */
export var ExploreApiFp = function (configuration) {
    return {
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:fetch_hits-{fetch_hits values}    Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.       - It&#x27;s possible to apply multiple metric aggregations by defining multiple (**collect_field**,**collect_fct**) couples.      - (**collect_field**,**collect_fct**) couples should be unique in that case.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           datehistogram, histogram, geohash, geotile and term.    - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6.           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - If {on} is equal to &#x60;result&#x60; and two or more (**collect_field**,**collect_fct**) couples are specified, then the order is applied on the first &#x60;collect_fct&#x60; that is different from geobbox and geocentroid   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell extent (zxy or geohash) of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the aggregated form, the geojson geometry and an attribute &#x60;is_raw&#x60; set to false       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,cell&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the geometry path, the used sort, the geojson geometry and an attribute &#x60;is_raw&#x60; set to true       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).aggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregatePost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).aggregatePost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {string} field The field on which the metric is calculated.
         * @param {string} metric The metric to compute : &#x60;max, min, avg, sum, cardinality, spanning, geobbox, geocentroid&#x60;.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        compute: function (collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).compute(collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {ComputationRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        computePost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).computePost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        count: function (collection, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).count(collection, f, q, dateformat, righthand, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Count} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        countPost: function (collection, body, pretty, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).countPost(collection, body, pretty, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Describe the structure and the content of the given collection.
         * @summary Describe
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        describe: function (collection, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).describe(collection, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geoaggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geoaggregatePost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given geohash as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geohash
         * @param {string} collection collection
         * @param {string} geohash geohash
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geohashgeoaggregate: function (collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geohashgeoaggregate(collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geosearch(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearchPost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geosearchPost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given tile as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geotile
         * @param {string} collection collection
         * @param {number} z z
         * @param {number} x x
         * @param {number} y y
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geotilegeoaggregate: function (collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).geotilegeoaggregate(collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Returns a raw indexed document.
         * @summary Get an Arlas document
         * @param {string} collection collection
         * @param {string} identifier identifier
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getArlasHit: function (collection, identifier, pretty, flat, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).getArlasHit(collection, identifier, pretty, flat, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * List the collections configured in ARLAS.
         * @summary List
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: function (pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).list(pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).search(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).searchPost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).shapeaggregate(collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).shapeaggregatePost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearch: function (collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).shapesearch(collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearchPost: function (collection, body, pretty, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).shapesearchPost(collection, body, pretty, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Suggest the the n (n=size) most relevant terms given the filters
         * @summary Suggest
         * @param {string} collections collections, comma separated
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided. The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator   |                   Description                      | value type          :          |  {fieldName} equals {value}                        | numeric or strings           :gte:      |  {fieldName} is greater than or equal to  {value}  | numeric           :gt:       |  {fieldName} is greater than {value}               | numeric           :lte:      |  {fieldName} is less than or equal to {value}      | numeric           :lt:       |  {fieldName}  is less than {value}                 | numeric       - The AND operator is applied between filters having different fieldNames.    - The OR operator is applied on filters having the same fieldName.    - If the fieldName starts with - then a must not filter is used   - If the fieldName starts with - then a must not filter is used   For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md
         * @param {string} [q] A full text search
         * @param {boolean} [pretty] Pretty print
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [field] Name of the field to be used for retrieving the most relevant terms
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        suggest: function (collections, f, q, pretty, size, from, field, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).suggest(collections, f, q, pretty, size, from, field, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch: function (collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).tiledgeosearch(collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [sampling] Size of the sampling for testing transparency: 1: test every pixel, 10: test 1 pixel every 10 pixels, etc.
         * @param {number} [coverage] Percentage (]0-100]) of acceptable transparent pixels. Higher the percentage, more tiles could be used for filling the tile
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch1: function (collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options) {
            var localVarFetchArgs = ExploreApiFetchParamCreator(configuration).tiledgeosearch1(collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = isomorphicFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
    };
};
/**
 * ExploreApi - factory interface
 * @export
 */
export var ExploreApiFactory = function (configuration, fetch, basePath) {
    return {
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:fetch_hits-{fetch_hits values}    Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.       - It&#x27;s possible to apply multiple metric aggregations by defining multiple (**collect_field**,**collect_fct**) couples.      - (**collect_field**,**collect_fct**) couples should be unique in that case.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           datehistogram, histogram, geohash, geotile and term.    - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6.           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - If {on} is equal to &#x60;result&#x60; and two or more (**collect_field**,**collect_fct**) couples are specified, then the order is applied on the first &#x60;collect_fct&#x60; that is different from geobbox and geocentroid   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell extent (zxy or geohash) of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the aggregated form, the geojson geometry and an attribute &#x60;is_raw&#x60; set to false       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,cell&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the geometry path, the used sort, the geojson geometry and an attribute &#x60;is_raw&#x60; set to true       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            return ExploreApiFp(configuration).aggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
         * @summary Aggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        aggregatePost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).aggregatePost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {string} field The field on which the metric is calculated.
         * @param {string} metric The metric to compute : &#x60;max, min, avg, sum, cardinality, spanning, geobbox, geocentroid&#x60;.
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        compute: function (collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).compute(collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Computes the given metric on a field in the collection, given the filters
         * @summary Compute
         * @param {string} collection collection
         * @param {ComputationRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        computePost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).computePost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        count: function (collection, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).count(collection, f, q, dateformat, righthand, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Count the number of elements found in the collection(s), given the filters
         * @summary Count
         * @param {string} collection collections
         * @param {Count} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        countPost: function (collection, body, pretty, options) {
            return ExploreApiFp(configuration).countPost(collection, body, pretty, options)(fetch, basePath);
        },
        /**
         * Describe the structure and the content of the given collection.
         * @summary Describe
         * @param {string} collection collection
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        describe: function (collection, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).describe(collection, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            return ExploreApiFp(configuration).geoaggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geoaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).geoaggregatePost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given geohash as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geohash
         * @param {string} collection collection
         * @param {string} geohash geohash
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geohashgeoaggregate: function (collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            return ExploreApiFp(configuration).geohashgeoaggregate(collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearch: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            return ExploreApiFp(configuration).geosearch(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters
         * @summary GeoSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geosearchPost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).geosearchPost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) and localized in the given tile as features, given the filters and the aggregation parameters.
         * @summary GeoAggregate on a geotile
         * @param {string} collection collection
         * @param {number} z z
         * @param {number} x x
         * @param {number} y y
         * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        geotilegeoaggregate: function (collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
            return ExploreApiFp(configuration).geotilegeoaggregate(collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Returns a raw indexed document.
         * @summary Get an Arlas document
         * @param {string} collection collection
         * @param {string} identifier identifier
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getArlasHit: function (collection, identifier, pretty, flat, max_age_cache, options) {
            return ExploreApiFp(configuration).getArlasHit(collection, identifier, pretty, flat, max_age_cache, options)(fetch, basePath);
        },
        /**
         * List the collections configured in ARLAS.
         * @summary List
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: function (pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).list(pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        search: function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            return ExploreApiFp(configuration).search(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection, given the filters
         * @summary Search
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        searchPost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).searchPost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregate: function (collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).shapeaggregate(collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
         * @summary ShapeAggregate
         * @param {string} collection collection
         * @param {AggregationsRequest} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapeaggregatePost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).shapeaggregatePost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearch: function (collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            return ExploreApiFp(configuration).shapesearch(collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
         * @summary ShapeSearch
         * @param {string} collection collection
         * @param {Search} [body]
         * @param {boolean} [pretty] Pretty print
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shapesearchPost: function (collection, body, pretty, max_age_cache, options) {
            return ExploreApiFp(configuration).shapesearchPost(collection, body, pretty, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Suggest the the n (n=size) most relevant terms given the filters
         * @summary Suggest
         * @param {string} collections collections, comma separated
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided. The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator   |                   Description                      | value type          :          |  {fieldName} equals {value}                        | numeric or strings           :gte:      |  {fieldName} is greater than or equal to  {value}  | numeric           :gt:       |  {fieldName} is greater than {value}               | numeric           :lte:      |  {fieldName} is less than or equal to {value}      | numeric           :lt:       |  {fieldName}  is less than {value}                 | numeric       - The AND operator is applied between filters having different fieldNames.    - The OR operator is applied on filters having the same fieldName.    - If the fieldName starts with - then a must not filter is used   - If the fieldName starts with - then a must not filter is used   For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md
         * @param {string} [q] A full text search
         * @param {boolean} [pretty] Pretty print
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [field] Name of the field to be used for retrieving the most relevant terms
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        suggest: function (collections, f, q, pretty, size, from, field, max_age_cache, options) {
            return ExploreApiFp(configuration).suggest(collections, f, q, pretty, size, from, field, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {boolean} [pretty] Pretty print
         * @param {boolean} [flat] Flats the property map: only key/value on one level
         * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
         * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
         * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch: function (collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
            return ExploreApiFp(configuration).tiledgeosearch(collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(fetch, basePath);
        },
        /**
         * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
         * @summary Tiled GeoSearch
         * @param {string} collection collection
         * @param {number} x x
         * @param {number} y y
         * @param {number} z z
         * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
         * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
         * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
         * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
         * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
         * @param {number} [from] From index to start the search from. Defaults to 0.
         * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
         * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
         * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
         * @param {number} [sampling] Size of the sampling for testing transparency: 1: test every pixel, 10: test 1 pixel every 10 pixels, etc.
         * @param {number} [coverage] Percentage (]0-100]) of acceptable transparent pixels. Higher the percentage, more tiles could be used for filling the tile
         * @param {number} [max_age_cache] max-age-cache
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tiledgeosearch1: function (collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options) {
            return ExploreApiFp(configuration).tiledgeosearch1(collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options)(fetch, basePath);
        },
    };
};
/**
 * ExploreApi - object-oriented interface
 * @export
 * @class ExploreApi
 * @extends {BaseAPI}
 */
var ExploreApi = (function (_super) {
    __extends(ExploreApi, _super);
    function ExploreApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
     * @summary Aggregate
     * @param {string} collection collection
     * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:fetch_hits-{fetch_hits values}    Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.       - It&#x27;s possible to apply multiple metric aggregations by defining multiple (**collect_field**,**collect_fct**) couples.      - (**collect_field**,**collect_fct**) couples should be unique in that case.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           datehistogram, histogram, geohash, geotile and term.    - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6.           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - If {on} is equal to &#x60;result&#x60; and two or more (**collect_field**,**collect_fct**) couples are specified, then the order is applied on the first &#x60;collect_fct&#x60; that is different from geobbox and geocentroid   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell extent (zxy or geohash) of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the aggregated form, the geojson geometry and an attribute &#x60;is_raw&#x60; set to false       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,cell&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: the aggregated geometries are returned in &#x60;geometries&#x60; list in the json response. Each object inside this list has : the reference to the geometry path, the used sort, the geojson geometry and an attribute &#x60;is_raw&#x60; set to true       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md.
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.aggregate = function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
        return ExploreApiFp(this.configuration).aggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s), given the filters and the aggregation parameters
     * @summary Aggregate
     * @param {string} collection collection
     * @param {AggregationsRequest} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.aggregatePost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).aggregatePost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Computes the given metric on a field in the collection, given the filters
     * @summary Compute
     * @param {string} collection collection
     * @param {string} field The field on which the metric is calculated.
     * @param {string} metric The metric to compute : &#x60;max, min, avg, sum, cardinality, spanning, geobbox, geocentroid&#x60;.
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.compute = function (collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).compute(collection, field, metric, f, q, dateformat, righthand, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Computes the given metric on a field in the collection, given the filters
     * @summary Compute
     * @param {string} collection collection
     * @param {ComputationRequest} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.computePost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).computePost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Count the number of elements found in the collection(s), given the filters
     * @summary Count
     * @param {string} collection collections
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.count = function (collection, f, q, dateformat, righthand, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).count(collection, f, q, dateformat, righthand, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Count the number of elements found in the collection(s), given the filters
     * @summary Count
     * @param {string} collection collections
     * @param {Count} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.countPost = function (collection, body, pretty, options) {
        return ExploreApiFp(this.configuration).countPost(collection, body, pretty, options)(this.fetch, this.basePath);
    };
    /**
     * Describe the structure and the content of the given collection.
     * @summary Describe
     * @param {string} collection collection
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.describe = function (collection, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).describe(collection, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
     * @summary GeoAggregate
     * @param {string} collection collection
     * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geoaggregate = function (collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geoaggregate(collection, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters.
     * @summary GeoAggregate
     * @param {string} collection collection
     * @param {AggregationsRequest} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geoaggregatePost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geoaggregatePost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) and localized in the given geohash as features, given the filters and the aggregation parameters.
     * @summary GeoAggregate on a geohash
     * @param {string} collection collection
     * @param {string} geohash geohash
     * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geohashgeoaggregate = function (collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geohashgeoaggregate(collection, geohash, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) as features, given the filters
     * @summary GeoSearch
     * @param {string} collection collection
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
     * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
     * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
     * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
     * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geosearch = function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geosearch(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) as features, given the filters
     * @summary GeoSearch
     * @param {string} collection collection
     * @param {Search} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geosearchPost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geosearchPost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) and localized in the given tile as features, given the filters and the aggregation parameters.
     * @summary GeoAggregate on a geotile
     * @param {string} collection collection
     * @param {number} z z
     * @param {number} x x
     * @param {number} y y
     * @param {Array<string>} [agg] - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.geotilegeoaggregate = function (collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options) {
        return ExploreApiFp(this.configuration).geotilegeoaggregate(collection, z, x, y, agg, f, q, dateformat, righthand, pretty, flat, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Returns a raw indexed document.
     * @summary Get an Arlas document
     * @param {string} collection collection
     * @param {string} identifier identifier
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.getArlasHit = function (collection, identifier, pretty, flat, max_age_cache, options) {
        return ExploreApiFp(this.configuration).getArlasHit(collection, identifier, pretty, flat, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * List the collections configured in ARLAS.
     * @summary List
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.list = function (pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).list(pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection, given the filters
     * @summary Search
     * @param {string} collection collection
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
     * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
     * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
     * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
     * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.search = function (collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
        return ExploreApiFp(this.configuration).search(collection, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection, given the filters
     * @summary Search
     * @param {string} collection collection
     * @param {Search} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.searchPost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).searchPost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
     * @summary ShapeAggregate
     * @param {string} collection collection
     * @param {Array<string>} agg - The agg parameter should be given in the following formats:            {type}:{field}:interval-{interval}:format-{format}:collect_field-{collect_field}:collect_fct-{function}:order-{order}:on-{on}:size-{size}:raw_geometries-{raw_geometries values}:aggregated_geometries-{aggregated_geometries values}:fetch_hits-{fetch_hits values}   Where :      - **{type}:{field}** part is mandatory.       - **interval** must be specified only when aggregation type is datehistogram, histogram, geotile and geohash.      - **format** is optional for datehistogram, and must not be specified for the other types.      - (**collect_field**,**collect_fct**) couple is optional for all aggregation types.      - (**order**,**on**) couple is optional for all aggregation types.      - **size** is optional for term and geohash/geotile, and must not be specified for the other types.      - **include** is optional for term, and must not be specified for the other types.   - {type} possible values are :           geohash, geotile, datehistogram, histogram and term. geohash or geotile must be the main aggregation.   - {interval} possible values depends on {type}.           If {type} &#x3D; datehistogram, then {interval} &#x3D; {size}(year,quarter,month,week,day,hour,minute,second). Size value must be equal to 1 for year,quarter,month and week unities.           If {type} &#x3D; histogram, then {interval} &#x3D; {size}.           If {type} &#x3D; geohash, then {interval} &#x3D; {size}. It&#x27;s an integer between 1 and 12. Lower the length, greater is the surface of aggregation.           If {type} &#x3D; geotile, then {interval} &#x3D; {size}. It&#x27;s an integer corresponding to zoom level of the aggregation, that should be larger than or equal to {z} in the path param, and no bigger than {z}+6 (max 29).           If {type} &#x3D; term, then interval-{interval} is not needed.    - format-{format} is the date format for key aggregation. The default value is yyyy-MM-dd-hh:mm:ss.   - {collect_fct} is the aggregation function to apply to collections on the specified {collect_field}.      {collect_fct} possible values are :           avg,cardinality,max,min,sum,geobbox,geocentroid   - (collect_field,collect_fct) should both be specified, except when collect_fct &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, it could be specified alone. The metrics &#x60;geobbox&#x60; and &#x60;geocentroid&#x60; are returned as features collections.   - {order} is set to sort the aggregation buckets on the field name, on the count of the buckets or on the the result of a metric sub-aggregation. Its values are &#x27;asc&#x27; or &#x27;desc&#x27;.    - {on} is set to specify whether the {order} is on the field name, on the count of the aggregation or on the result of a metric sub-aggregation. Its values are &#x27;field&#x27;, &#x27;count&#x27; or &#x27;result&#x27;.    - When {on} &#x3D; &#x60;result&#x60;, then (collect_field,collect_fct) should be specified. Except when {collect_fct} &#x3D; &#x60;geobbox&#x60; or &#x60;geocentroid&#x60;, then {on}&#x3D;&#x60;result&#x60; is prohibited   - {size} Defines how many buckets should be returned.    - {include} Specifies the values for which buckets will be created. This values are comma separated. If one value is specified then regular expressions can be used (only in this case) and buckets matching them will be created. If more than one value are specified then only buckets matching the exact values will be created.   - **aggregated_geometries**       &gt; **What it does**: Allows to specify a list of aggregated forms of geometries that represent the bucket.       &gt; __**Syntax**__: &#x60;aggregated_geometries-{COMMA_SEPARATED_AGGREGATED_GEOMETRIES}&#x60;.       &gt; __**Available aggregated geometries**__: &#x60;centroid, bbox, cell, cell_center&#x60;.          - **centroid**: returns the centroid of data inside the bucket.          - **bbox**: returns the data extent (bbox) in each bucket.          - **cell**: returns the cell (zxy or geohash) extent of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.          - **cell_center**: returns the cell center of each bucket. This form is supported for **geohash** and **geotile** aggregation type only.       &gt; __**Response**__: Each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified aggregated geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which aggregated form is returned           - **geometry_type** attribute set to *aggregated*       &gt; __**Example**__: &#x60;aggregated_geometries-bbox,geohash&#x60;   - **raw_geometries**       &gt; **What it does**: Allows to specify a list of raw geometries provided by hits that represent the bucket and that are elected by a sort       &gt; __**Syntax**__: &#x60;raw_geometries-{GEOMETRY_FIELD}({COMMA_SEPERATED_SORT_FIELDS});{GEOMETRY_FIELD2}({COMMA_SEPERATED_SORT_FIELDS2})&#x60;.       &gt; __**Available raw geometries**__: any field of the collection whose type is **geo-point** or **geo-shape**.          - sort fields are optional. If no sort is specified, an ascending sort on &#x60;collection.params.timestamp_path&#x60; is applied          - a sort field can be preceded by &#x27;-&#x27; for descending sort. Otherwise the sort is ascending       &gt; __**Response**__: each bucket of the aggregation will be represented with as many features (in a feature collection) as there are specified raw geometries. The properties of each feature has :          - **geometry_ref** attribute that informs which geometry path is returned           - **geometry_type** attribute set to *raw*          - **geometry_sort** attribute that informs how the geometry path is fetched (with what sort)       &gt; __**Example**__: &#x60;raw_geometries-geo_field1,geo_field2  ||  raw_geometries-geo_field(-field1,field2)&#x60; || raw_geometries-geo_field1(field1);geo_field2(field2,field3)   - **fetch_hits**        &gt; **What it does**: Specifies the number of hits to retrieve inside each aggregation bucket and which fields to include in the hits.       &gt; __**Syntax**__: &#x60;fetch_hits-{sizeOfHitsToFetch}(+{field1}, {field2}, -{field3}, ...)&#x60;.       &gt; **Note 1**: &#x60;{sizeOfHitsToFetch}&#x60; is optional, if not specified, 1 is considered as default.       &gt; **Note 2**: &#x60;{field}&#x60; can be preceded by **+** or **-** for **ascending** or **descending** sort of the hits. Order matters.       &gt; __**Example**__: &#x60;fetch_hits-3(-timestamp, geometry)&#x60;. Fetches the 3 last positions for each bucket.   **agg** parameter is multiple. The first (main) aggregation must be geohash or geotile. Every agg parameter specified is a subaggregation of the previous one : order matters.    For more details, check https://github.com/gisaia/ARLAS-server/blob/master/docs/arlas-api-exploration.md
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.shapeaggregate = function (collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).shapeaggregate(collection, agg, f, q, dateformat, righthand, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Aggregate the elements in the collection(s) as features, given the filters and the aggregation parameters, and returns a shapefile of it.
     * @summary ShapeAggregate
     * @param {string} collection collection
     * @param {AggregationsRequest} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.shapeaggregatePost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).shapeaggregatePost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
     * @summary ShapeSearch
     * @param {string} collection collection
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
     * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
     * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
     * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
     * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.shapesearch = function (collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
        return ExploreApiFp(this.configuration).shapesearch(collection, f, q, dateformat, righthand, pretty, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) as features, given the filters, exported as a Shapefile
     * @summary ShapeSearch
     * @param {string} collection collection
     * @param {Search} [body]
     * @param {boolean} [pretty] Pretty print
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.shapesearchPost = function (collection, body, pretty, max_age_cache, options) {
        return ExploreApiFp(this.configuration).shapesearchPost(collection, body, pretty, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Suggest the the n (n=size) most relevant terms given the filters
     * @summary Suggest
     * @param {string} collections collections, comma separated
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided. The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator   |                   Description                      | value type          :          |  {fieldName} equals {value}                        | numeric or strings           :gte:      |  {fieldName} is greater than or equal to  {value}  | numeric           :gt:       |  {fieldName} is greater than {value}               | numeric           :lte:      |  {fieldName} is less than or equal to {value}      | numeric           :lt:       |  {fieldName}  is less than {value}                 | numeric       - The AND operator is applied between filters having different fieldNames.    - The OR operator is applied on filters having the same fieldName.    - If the fieldName starts with - then a must not filter is used   - If the fieldName starts with - then a must not filter is used   For more details, check https://gitlab.com/GISAIA.ARLAS/ARLAS-server/blob/master/doc/api/API-definition.md
     * @param {string} [q] A full text search
     * @param {boolean} [pretty] Pretty print
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [field] Name of the field to be used for retrieving the most relevant terms
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.suggest = function (collections, f, q, pretty, size, from, field, max_age_cache, options) {
        return ExploreApiFp(this.configuration).suggest(collections, f, q, pretty, size, from, field, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
     * @summary Tiled GeoSearch
     * @param {string} collection collection
     * @param {number} x x
     * @param {number} y y
     * @param {number} z z
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {boolean} [pretty] Pretty print
     * @param {boolean} [flat] Flats the property map: only key/value on one level
     * @param {string} [include] List the name patterns of the field to be included in the result. Separate patterns with a comma.
     * @param {string} [exclude] List the name patterns of the field to be excluded in the result. Separate patterns with a comma.
     * @param {string} [returned_geometries] Comma separated geometry field_paths to be included in the result. If not specified, only geometry_path is returned. If geometry_path is null, then centroid_path is returned
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
     * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
     * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.tiledgeosearch = function (collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options) {
        return ExploreApiFp(this.configuration).tiledgeosearch(collection, x, y, z, f, q, dateformat, righthand, pretty, flat, include, exclude, returned_geometries, size, from, sort, after, before, max_age_cache, options)(this.fetch, this.basePath);
    };
    /**
     * Search and return the elements found in the collection(s) and localized in the given tile(x,y,z) as features, given the filters
     * @summary Tiled GeoSearch
     * @param {string} collection collection
     * @param {number} x x
     * @param {number} y y
     * @param {number} z z
     * @param {Array<string>} [f] - A triplet for filtering the result. Multiple filter can be provided in distinct parameters (AND operator is applied) or in the same parameter separated by semi-colons (OR operator is applied). The order does not matter.    - A triplet is composed of a field name, a comparison operator and a value.      The possible values of the comparison operator are :           Operator        --                   Description                    -- value type          :eq:            -- {fieldName} equals {comma separated values}. **OR** operation is applied for the specified values -- numeric or strings           :ne:            -- {fieldName} must not equal {comma separated values }. **AND** operation is applied for the specified values -- numeric or strings           :like:          -- {fieldName}  is like {value}                     -- numeric or strings           :gte:           -- {fieldName} is greater than or equal to  {value} -- numeric           :gt:            -- {fieldName} is greater than {value}              -- numeric           :lte:           -- {fieldName} is less than or equal to {value}     -- numeric           :lt:            -- {fieldName}  is less than {value}                -- numeric           :range:         -- {fieldName} is between &#x60;{comma separated [min&lt;max] values}&#x60;. **OR** operation is applied for the specified ranges -- numeric or strings. If the field&#x27;s type is date, then min &amp; max should be timestamps in millisecond or a Date expression          :within:        -- {GeofieldName}&#x60; is within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notwithin:     -- {GeofieldName} is not within the &#x60;{given WKT string or the given BBOX }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :intersects:    -- {GeofieldName} intersects the &#x60;{given WKT string or the given BBOX }&#x60; | a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;           :notintersects: -- {GeofieldName} does not intersect the &#x60;{given WKT string or the given }&#x60; -- a WKT string or the BBOX string : &#x60;\&quot;west, south, east, north\&quot;&#x60;
     * @param {Array<string>} [q] A full text search. Optionally, it&#x27;s possible to search on a field using this syntax: {fieldname}:{text}
     * @param {string} [dateformat] The format of dates. This parameter should be set only if a date field is queried in &#x60;f&#x60; param; when using &#x60;gt&#x60;, &#x60;lt&#x60;, &#x60;gte&#x60;, &#x60;lte&#x60; and &#x60;range&#x60; operations
     * @param {boolean} [righthand] If righthand &#x3D; true, the passed WKT should be counter clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.   Inversely, If righthand &#x3D; false, the passed WKT should be clock-wise; otherwise, ARLAS-server will attempt to parse it as the \&quot;Complementary\&quot; Polygon on the other facet of the planet.
     * @param {number} [size] The maximum number of entries or sub-entries to be returned. The default value is 10
     * @param {number} [from] From index to start the search from. Defaults to 0.
     * @param {string} [sort] Sorts the resulted hits on the given fields and/or by distance to a given point:   &gt; __**Syntax**__: &#x60;{field1},{field2},-{field3},geodistance:{lat} {lon},{field4}  ...&#x60;.   &gt; **Note 1**: &#x60;{field}&#x60; can be preceded by **&#x27;-&#x27;**  for **descending** sort. By default, sort is ascending.   &gt; **Note 2**: The order of fields matters.   &gt; **Note 3** ***geodistance sort***: Sorts the hits centroids by distance to the given **{lat} {lon}** (ascending distance sort). It can be specified at most 1 time.   &gt; __**Example 1**__: sort&#x3D;&#x60;age,-timestamp&#x60;. Resulted hits are sorted by age. For same age hits, they are decreasingly sorted in time.   &gt; __**Example 2**__: sort&#x3D;&#x60;age,geodistance:89 179&#x60;. Resulted hits are sorted by age. For same age hits, they are sorted by closest distance to the point(89°,179°)
     * @param {string} [after] List of values of fields present in sort param that are used to search after.    &gt; **What it does**: Retrieve the data placed after the pointed element, given the provided order (sort).   &gt; __**Restriction 1**__: **after** param works only combined with **sort** param.   &gt; __**Syntax**__: &#x60;after&#x3D;{value1},{value2},...,{valueN} &amp; sort&#x3D;{field1},{field2},...,{fieldN}&#x60;.   &gt; **Note 1**: *{value1}&#x60; and &#x60;{value2}&#x60; are the values of &#x60;{field1}&#x60; and &#x60;{field2}&#x60; in the last hit returned in the previous search   &gt; **Note 2**: The order of fields and values matters. *{value1},{value2}* must be in the same order of *{field1},{field2}* in **sort** param   &gt; **Note 3**:  The last field &#x60;{fieldN}&#x60; must be the id field specified in the collection **collection.params.idPath** (returned as **md.id**) and &#x60;{valueN}&#x60; its corresponding value.   &gt; __**Example**__: *sort&#x3D;&#x60;-date,id&#x60; &amp; **after**&#x3D;&#x60;01/02/2019,abcd1234&#x60;*. Gets the following hits of the previous search that stopped at date *01/02/2019* and id *abcd1234*.   &gt; __**Restriction 2**__: **from** param must be set to 0 or kept unset
     * @param {string} [before] Same idea that after param, but to retrieve the data placed before the pointed element, given the provided order (sort).
     * @param {number} [sampling] Size of the sampling for testing transparency: 1: test every pixel, 10: test 1 pixel every 10 pixels, etc.
     * @param {number} [coverage] Percentage (]0-100]) of acceptable transparent pixels. Higher the percentage, more tiles could be used for filling the tile
     * @param {number} [max_age_cache] max-age-cache
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ExploreApi
     */
    ExploreApi.prototype.tiledgeosearch1 = function (collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options) {
        return ExploreApiFp(this.configuration).tiledgeosearch1(collection, x, y, z, f, q, dateformat, righthand, size, from, sort, after, before, sampling, coverage, max_age_cache, options)(this.fetch, this.basePath);
    };
    return ExploreApi;
}(BaseAPI));
export { ExploreApi };
//# sourceMappingURL=api.js.map